package com.ruoyi.framework.web.service;

import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.MessageUtils;
import com.ruoyi.common.utils.lang.LangUnit;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.enums.UserStatus;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.system.service.ISysUserService;

/**
 * 用户验证处理
 *
 * @author ruoyi
 */
@Service
public class UserDetailsServiceImpl implements UserDetailsService
{
    private static final Logger log = LoggerFactory.getLogger(UserDetailsServiceImpl.class);

    @Autowired
    private ISysUserService userService;

    @Autowired
    private SysPasswordService passwordService;

    @Autowired
    private SysPermissionService permissionService;

    @Autowired
    private LangUnit langUnit;

    @Override
    public UserDetails loadUserByUsername(String userInfo) throws UsernameNotFoundException
    {
        String[] userInfoArr = userInfo.split(",");
        String username = userInfoArr[0];
        String language = userInfoArr[1];
        SysUser user = userService.selectUserByUserName(username);
        if (StringUtils.isNull(user))
        {
            log.info("登录用户：{} 不存在.", username);
            //String msg = StringUtils.format(langUnit.getValueTag("login.user.not.exists", "登录用户：{} 不存在"), username);
            String msg = StringUtils.format(MessageUtils.message("login.user.not.exists", language), username);
            //throw new ServiceException("登录用户：" + username + " 不存在");
            throw new ServiceException(msg);
        }
        else if (UserStatus.DELETED.getCode().equals(user.getDelFlag()))
        {
            log.info("登录用户：{} 已被删除.", username);
            //String msg = StringUtils.format(langUnit.getValueTag("user.password.delete", "对不起，您的账号：{} 已被删除"), username);
            String msg = StringUtils.format(MessageUtils.message("user.password.delete", language), username);
            //throw new ServiceException("对不起，您的账号：" + username + " 已被删除");
            throw new ServiceException(msg);
        }
        else if (UserStatus.DISABLE.getCode().equals(user.getStatus()))
        {
            log.info("登录用户：{} 已被停用.", username);
            //String msg = StringUtils.format(langUnit.getValueTag("user.account.blocked", "对不起，您的账号：{} 已停用"), username);
            String msg = StringUtils.format(MessageUtils.message("user.account.blocked", language), username);
            //throw new ServiceException("对不起，您的账号：" + username + " 已停用");
            throw new ServiceException(msg);
        }
        else if (UserStatus.PENDING.getCode().equals(user.getStatus()))
        {
            log.info("登录用户：{} 注册审核中.", username);
            //String msg = StringUtils.format(langUnit.getValueTag("user.account.blocked", "对不起，您的账号：{} 已停用"), username);
            String msg = StringUtils.format(MessageUtils.message("user.account.register.pending", language), username);
            //throw new ServiceException("对不起，您的账号：" + username + " 已停用");
            throw new ServiceException(msg);
        }

        passwordService.validate(user, language);

        return createLoginUser(user);
    }

    public UserDetails createLoginUser(SysUser user)
    {
        return new LoginUser(user.getUserId(), user.getDeptId(), user, permissionService.getMenuPermission(user));
    }
}
